
--[[
Title : Pong
Author : Carl Reed - aka - CaptainMaelstrom
Date : 3-4-13
Purpose : Small project to practice game design.
License : 
]]

require 'scripts/aliases'
require 'scripts/input'
require 'scripts/drawing'

function love.load()
	p1y = 40
	p2y =  40
	ball = { x=sw/2, y=sh/2, xdir = math.random(0,1), ydir = math.random(0,1)}
	
	if ball.xdir == 0 then ball.xdir = -1 end
	if ball.ydir == 0 then ball.ydir = -1 end
	
	timer = 0
	aiFollow = false

	high = newSound('sounds/high.mp3')
	mid = newSound('sounds/mid.mp3')
	low = newSound('sounds/low.mp3')
	gong = newSound('sounds/gong.mp3')
	
end

function love.update(dt)
	timer = timer+dt
	
	if ball.x+12 < 0 then	--p2 scores
	timer = 0
	score.p2 = score.p2+1
	ball.x = sw/2
	ball.y = sh/2
	ball.xdir = math.random(0,1)
	love.audio.play(gong)
	if ball.xdir == 0 then ball.xdir = -1 end
	end
	
	if ball.x-12 > sw then	--p1 scores
	timer = 0
	score.p1 = score.p1+1
	ball.x = sw/2
	ball.y = sh/2
	ball.xdir = math.random(0,1)
	love.audio.play(gong)
	if ball.xdir == 0 then ball.xdir = -1 end
	end
	
	if timer > 1 then
	ball.x = ball.x+275*ball.xdir*dt	--move ball
	ball.y = ball.y+275*ball.ydir*dt
	end
	
	if keyW and p1y > 0 then p1y = p1y-250*dt end	--move p1
	if keyS and p1y < 500 then p1y = p1y+250*dt end
	
	if lastframe.bx <= 200 and ball.x > 200 then ai(.25) end
	if lastframe.bx <= 300 and ball.x > 300 then ai(.35) end
	if lastframe.bx <= 400 and ball.x > 400 then ai(.85) end
	if lastframe.bx <= 500 and ball.x > 500 then ai(.5) end
	
	if lastframe.bx >= 200 and ball.x < 200 then ai(.15) end
	if lastframe.bx >= 300 and ball.x < 300 then ai(.1) end
	if lastframe.bx >= 400 and ball.x < 400 then ai(.15) end
	if lastframe.bx >= 100 and ball.x < 100 then ai(.1) end
	
	if aiFollow and p2y+50 > ball.y then p2y = p2y-220*dt end
	if aiFollow and p2y+50 < ball.y then p2y = p2y+220*dt end
	if p2y < 0 then p2y = 0 end
	if p2y > 500 then p2y = 500 end
	
	if (ball.x - 12) < 40 and (ball.x-12) > 25 and ball.y < (p1y+108) and ball.y > (p1y-8) then ball.xdir = 1
	love.audio.play(high)	end	--detect ball collision with player bars
	if (ball.x + 12) > sw-40 and (ball.x+12) < sw-40+15 and ball.y < (p2y+108) and ball.y > (p2y-8) then ball.xdir = -1
	love.audio.play(low) end
	
	if ball.y-12 < 0 then ball.ydir = ball.ydir*-1
	love.audio.play(mid)	end	--detect ball collision with top and bottom of screen
	if ball.y+12 > sh then ball.ydir = ball.ydir*-1
	love.audio.play(mid)	end
	
	lastframe.p1y = p1y
	lastframe.p2y = p2y
	lastframe.bx = ball.x
	lastframe.by = ball.y
	lastframe.s1 = score.p1
	lastframe.s2 = score.p2
	
end

function love.draw()

	setFont(font36)	--draw score
	clr(255,255,255)
	p(tostring(score.p1), 350-36/2-36*(ordersOfMag(score.p1)-1), 50)
	p(tostring(score.p2), 450, 50)

	clr(100,100,100)	--draw middle line
	rect('fill', 395, 0, 10, 600)

	clr(255,255,255)
	rect('fill', 40-15, p1y, 15, 100)	--draw player bars
	rect('fill', sw-40, p2y, 15, 100)
	
	circ('fill', ball.x, ball.y, 12, 32)	-- draw ball
	
end

function ai(x)
	if math.random() < x then aiFollow = true
	else aiFollow = false end
end

